;;;-*-Mode: LISP; Package: CCL -*-
;;;
;;;   Copyright (C) 2001 Clozure Associates
;;;   This file is part of OpenMCL.  
;;;
;;;   OpenMCL is licensed under the terms of the Lisp Lesser GNU Public
;;;   License , known as the LLGPL and distributed with OpenMCL as the
;;;   file "LICENSE".  The LLGPL consists of a preamble and the LGPL,
;;;   which is distributed with OpenMCL as the file "LGPL".  Where these
;;;   conflict, the preamble takes precedence.  
;;;
;;;   OpenMCL is referenced in the preamble as the "LIBRARY."
;;;
;;;   The LLGPL is also available online at
;;;   http://opensource.franz.com/preamble.html

(in-package "CCL")

(defpackage "LINUX-SYSCALLS" (:use)
            #+linuxppc-target (:nicknames "SYSCALLS"))

(defvar *linux-syscalls* (make-hash-table :test #'eq))


(eval-when (:compile-toplevel :load-toplevel :execute)
  (require "SYSCALL"))







(define-syscall linux-syscalls::exit 1 (:signed-fullword) :void)
(define-syscall linux-syscalls::fork 2 () :signed-fullword)
(define-syscall linux-syscalls::read 3 (:unsigned-fullword :address :unsigned-fullword)
		:signed-fullword)
(define-syscall linux-syscalls::write 4 (:unsigned-fullword :address :unsigned-fullword)
		:signed-fullword)
(define-syscall linux-syscalls::open 5 (:address :unsigned-fullword :unsigned-fullword) :signed-fullword :min-args 2)
(define-syscall linux-syscalls::close 6 (:unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::waitpid 7 (:unsigned-fullword :address :signed-fullword)
		:signed-fullword)
(define-syscall linux-syscalls::creat 8 (:address :unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::link 9 (:address :address) :signed-fullword)
(define-syscall linux-syscalls::unlink 10 (:address) :signed-fullword )
(define-syscall linux-syscalls::execve 11 (:address :address :address) :signed-fullword )
(define-syscall linux-syscalls::chdir 12 (:address) :signed-fullword )
(define-syscall linux-syscalls::time 13 (:address) :unsigned-fullword )
(define-syscall linux-syscalls::mknod 14 (:address :unsigned-fullword :unsigned-fullword)
		:signed-fullword)
(define-syscall linux-syscalls::chmod 15 (:address :unsigned-fullword) :signed-fullword)
(define-syscall linux-syscalls::lchown 16 (:address :unsigned-fullword :unsigned-fullword)
		:signed-fullword)
;(define-syscall linux-syscalls::oldstat 18 () )
(define-syscall linux-syscalls::lseek 19 (:unsigned-fullword :signed-fullword :unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::getpid 20 () :unsigned-fullword)
(define-syscall linux-syscalls::mount 21 (:address
				 :address
				 :address
				 :unsigned-fullword
				 :address) :signed-fullword )
(define-syscall linux-syscalls::umount 22 (:address) :signed-fullword )

(define-syscall linux-syscalls::setuid 23 (:unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::getuid 24 () :unsigned-fullword )
(define-syscall linux-syscalls::stime 25 (:address) :signed-fullword )
(define-syscall linux-syscalls::ptrace 26 (:unsigned-fullword
				  :unsigned-fullword
				  :address
				  :address)
		:signed-fullword)
(define-syscall linux-syscalls::alarm 27 (:unsigned-fullword) :unsigned-fullword )

(define-syscall linux-syscalls::pause 29 () :signed-fullword)
(define-syscall linux-syscalls::utime 30 (:address :address) :signed-fullword )
(define-syscall linux-syscalls::access 33 (:address :unsigned-fullword) :signed-fullword)
(define-syscall linux-syscalls::nice 34 (:signed-fullword) :signed-fullword )
(define-syscall linux-syscalls::sync 36 () :unsigned-fullword )
(define-syscall linux-syscalls::kill 37 (:signed-fullword :unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::rename 38 (:address :address) :signed-fullword )
(define-syscall linux-syscalls::mkdir 39 (:address :unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::rmdir 40 (:address) :signed-fullword )
(define-syscall linux-syscalls::dup 41 (:unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::pipe 42 (:address) :signed-fullword )
(define-syscall linux-syscalls::times 43 (:address) :unsigned-fullword )

(define-syscall linux-syscalls::brk 45 (:address) :signed-fullword )
(define-syscall linux-syscalls::setgid 46 (:unsigned-fullword) :signed-fullword)
(define-syscall linux-syscalls::getgid 47 () :unsigned-fullword )
(define-syscall linux-syscalls::signal 48 (:unsigned-fullword :address) :address )
(define-syscall linux-syscalls::geteuid 49 () :unsigned-fullword )
(define-syscall linux-syscalls::getegid 50 () :unsigned-fullword)
(define-syscall linux-syscalls::acct 51 (:address) :signed-fullword )
(define-syscall linux-syscalls::umount2 52 (:address) :signed-fullword )
(define-syscall linux-syscalls::ioctl 54 (:unsigned-fullword :signed-fullword :address) :signed-fullword :min-args 2 )
(define-syscall linux-syscalls::fcntl 55 (:unsigned-fullword :signed-fullword :signed-fullword) :signed-fullword :min-args 2 )
(define-syscall linux-syscalls::setpgid 57 (:signed-fullword :signed-fullword) :signed-fullword )
(define-syscall linux-syscalls::umask 60 (:unsigned-fullword) :unsigned-fullword )
(define-syscall linux-syscalls::chroot 61 (:address) :signed-fullword )
(define-syscall linux-syscalls::ustat 62 (:unsigned-fullword :address) :signed-fullword )
(define-syscall linux-syscalls::dup2 63 (:unsigned-fullword :unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::getppid 64 () :unsigned-fullword)
(define-syscall linux-syscalls::getpgrp 65 () :unsigned-fullword)
(define-syscall linux-syscalls::setsid 66 () :signed-fullword)
(define-syscall linux-syscalls::sigaction 67 (:unsigned-fullword :address :address) :signed-fullword )
(define-syscall linux-syscalls::getrusage 77 (:signed-fullword :address) :signed-fullword)
(define-syscall linux-syscalls::gettimeofday 78 (:address :address) :void)
(define-syscall linux-syscalls::ftruncate 93 (:unsigned-fullword :unsigned-fullword)
		:signed-fullword)
(define-syscall linux-syscalls::fchmod 94 (:unsigned-fullword :unsigned-fullword)
		:signed-fullword )
(define-syscall linux-syscalls::socketcall 102 (:unsigned-fullword :address) :signed-fullword )
(define-syscall linux-syscalls::stat 106 (:address :address) :signed-fullword)
(define-syscall linux-syscalls::lstat 107 (:address :address) :signed-fullword)
(define-syscall linux-syscalls::fstat 108 (:unsigned-fullword :address) :signed-fullword )

(define-syscall linux-syscalls::fsync 118 (:unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::uname 122  (:address) :signed-fullword)
(define-syscall linux-syscalls::fchdir 133 (:unsigned-fullword) :signed-fullword )
(define-syscall linux-syscalls::_llseek 140 (:unsigned-fullword :unsigned-fullword :unsigned-fullword :address :unsigned-fullword) :signed-fullword )
(define-syscall	linux-syscalls::select 142 (:unsigned-fullword :address :address
                                                  :address :address)
                :signed-fullword)
(define-syscall linux-syscalls::getcwd 182 (:address :unsigned-fullword) :signed-fullword )



#+notdefinedyet
(progn
(define-syscall linux-syscalls::sgetmask 68 () )
(define-syscall linux-syscalls::ssetmask 69 () )
(define-syscall linux-syscalls::setreuid 70 () )
(define-syscall linux-syscalls::setregid 71 () )
(define-syscall linux-syscalls::sigsuspend 72 () )
(define-syscall linux-syscalls::sigpending 73 () )
(define-syscall linux-syscalls::sethostname 74 () )
(define-syscall linux-syscalls::setrlimit 75 () )
(define-syscall linux-syscalls::getrlimit 76 () )
(define-syscall linux-syscalls::settimeofday 79 () )
(define-syscall linux-syscalls::getgroups 80 () )
(define-syscall linux-syscalls::setgroups 81 () )
(define-syscall linux-syscalls::symlink 83 () )
(define-syscall linux-syscalls::oldlstat 84 () )
(define-syscall linux-syscalls::readlink 85 () )
(define-syscall linux-syscalls::uselib 86 () )
(define-syscall linux-syscalls::swapon 87 () )
(define-syscall linux-syscalls::reboot 88 () )
(define-syscall linux-syscalls::readdir 89 () )
(define-syscall linux-syscalls::mmap 90 () )
(define-syscall linux-syscalls::munmap 91 () )
(define-syscall linux-syscalls::truncate 92 () )

(define-syscall linux-syscalls::fchown 95 () )
(define-syscall linux-syscalls::getpriority 96 () )
(define-syscall linux-syscalls::setpriority 97 () )
(define-syscall linux-syscalls::statfs 99 () )
(define-syscall linux-syscalls::fstatfs 100 () )
(define-syscall linux-syscalls::ioperm 101 () )
(define-syscall linux-syscalls::syslog 103 () )
(define-syscall linux-syscalls::setitimer 104 () )
(define-syscall linux-syscalls::getitimer 105 () )
(define-syscall linux-syscalls::olduname 109 () )
(define-syscall linux-syscalls::iopl 110 () )
(define-syscall linux-syscalls::vhangup 111 () )
(define-syscall linux-syscalls::idle 112 () )
(define-syscall linux-syscalls::vm86 113 () )
(define-syscall linux-syscalls::wait4 114 () )
(define-syscall linux-syscalls::swapoff 115 () )
(define-syscall linux-syscalls::sysinfo 116 () )
(define-syscall linux-syscalls::ipc 117 () )
(define-syscall linux-syscalls::sigreturn 119 () )
(define-syscall linux-syscalls::clone 120 () )
(define-syscall linux-syscalls::setdomainname 121 () )
(define-syscall linux-syscalls::modify_ldt 123 () )
(define-syscall linux-syscalls::adjtimex 124 () )
(define-syscall linux-syscalls::mprotect 125 () )
(define-syscall linux-syscalls::sigprocmask 126 () )
(define-syscall linux-syscalls::create_module	127 () )
(define-syscall linux-syscalls::init_module	128 () )
(define-syscall linux-syscalls::delete_module	129 () )
(define-syscall linux-syscalls::get_kernel_syms	130 () )
(define-syscall linux-syscalls::quotactl 131 () )
(define-syscall linux-syscalls::getpgid 132 () )
(define-syscall linux-syscalls::bdflush 134 () )
(define-syscall linux-syscalls::sysfs 135 () )
(define-syscall linux-syscalls::personality 136 () )
(define-syscall linux-syscalls::setfsuid 138 () )
(define-syscall linux-syscalls::setfsgid 139 () )
(define-syscall linux-syscalls::getdents 141 () )
(define-syscall linux-syscalls::_newselect 142 () )
(define-syscall linux-syscalls::flock 143 () )
(define-syscall linux-syscalls::msync 144 () )
(define-syscall linux-syscalls::readv 145 () )
(define-syscall linux-syscalls::writev 146 () )
(define-syscall linux-syscalls::getsid 147 () )
(define-syscall linux-syscalls::fdatasync 148 () )
(define-syscall linux-syscalls::_sysctl 149 () )
(define-syscall linux-syscalls::mlock 150 () )
(define-syscall linux-syscalls::munlock 151 () )
(define-syscall linux-syscalls::mlockall 152 () )
(define-syscall linux-syscalls::munlockall 153 () )
(define-syscall linux-syscalls::sched_setparam 154 () )
(define-syscall linux-syscalls::sched_getparam 155 () )
(define-syscall linux-syscalls::sched_setscheduler 156 () )
(define-syscall linux-syscalls::sched_getscheduler 157 () )
(define-syscall linux-syscalls::sched_yield 158 () )
(define-syscall linux-syscalls::sched_get_priority_max 159 () )
(define-syscall linux-syscalls::sched_get_priority_min 160 () )
(define-syscall linux-syscalls::sched_rr_get_interval 161 () )
(define-syscall linux-syscalls::nanosleep 162 () )
(define-syscall linux-syscalls::mremap 163 () )
(define-syscall linux-syscalls::setresuid 164 () )
(define-syscall linux-syscalls::getresuid 165 () )
(define-syscall linux-syscalls::query_module	166 () )
(define-syscall linux-syscalls::poll 167 () )
(define-syscall linux-syscalls::nfsservctl 168 () )
(define-syscall linux-syscalls::setresgid 169 () )
(define-syscall linux-syscalls::getresgid 170 () )
(define-syscall linux-syscalls::prctl 171 () )
(define-syscall linux-syscalls::rt_sigreturn 172 () )
(define-syscall linux-syscalls::rt_sigaction 173 () )
(define-syscall linux-syscalls::rt_sigprocmask 174 () )
(define-syscall linux-syscalls::rt_sigpending 175 () )
(define-syscall linux-syscalls::rt_sigtimedwait 176 () )
(define-syscall linux-syscalls::rt_sigqueueinfo 177 () )
(define-syscall linux-syscalls::rt_sigsuspend 178 () )
(define-syscall linux-syscalls::pread 179 () )
(define-syscall linux-syscalls::pwrite 180 () )
(define-syscall linux-syscalls::chown 181 (:address) )

(define-syscall linux-syscalls::capget 183 () )
(define-syscall linux-syscalls::capset 184 () )
(define-syscall linux-syscalls::sigaltstack 185 () )
(define-syscall linux-syscalls::sendfile 186 () )
(define-syscall linux-syscalls::getpmsg 187	 () )
(define-syscall linux-syscalls::putpmsg 188	 () )
(define-syscall linux-syscalls::vfork 189 () )

)
